#if !defined(_GLOBALS_H_)
#define _GLOBALS_H_

#include "stdafx.h"

#define _Version_  "4.3.4"
#define EscKey          27
#define SpaceKey        32
#define EnterKey        13
#define UpKey           72
#define DownKey         80
#define PageUpKey       73
#define PageDownKey     81

#if !defined(_MAX_DRIVE)
#define _MAX_DRIVE       3
#endif
#if !defined(_MAX_DIR)
#define _MAX_DIR         66
#endif
#if !defined(_MAX_PATH)
#define _MAX_PATH        80
#endif
#if !defined(_MAX_FNAME)
#define _MAX_FNAME       13
#endif
#if !defined(_MAX_EXT)
#define _MAX_EXT         4
#endif

#define _MAX_SNAME       8
#define _MAX_SEXT        3

#if !defined(_A_NORMAL)
#define _A_NORMAL   0x00
#endif
#if !defined(_A_RDONLY)
#define _A_RDONLY   0x01
#endif
#if !defined(_A_HIDDEN)
#define _A_HIDDEN   0x02
#endif
#if !defined(_A_SYSTEM)
#define _A_SYSTEM   0x04
#endif
#if !defined(_A_SUBDIR)
#define _A_SUBDIR   0x10
#endif
#if !defined(_A_ARCH)
#define _A_ARCH     0x20
#endif

#if !defined(_MAX_LABEL)
#define _MAX_LABEL  33
#endif

#define _MB_ 1048576				//Megabyte
#define _GB_ 1073741824				//Gigabyte
#define _TB_ 1099511627776			//Terabyte
#define _PB_ 1125899906842624		//Petabyte
#define _EB_ 1152921504606846976	//Exabyte (64 bits maps 8 of these)

#if !defined(__COLORS)
#define __COLORS

enum COLORS {
    BLACK,
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};

#endif

struct dirinfo {
	unsigned short TFiles;
	unsigned short TDirectories;
	unsigned       LFname;
	unsigned       LExt;
	char           Path[_MAX_PATH];
	char           DLabel[_MAX_LABEL];
	char           DriveSize[10];
	char           DriveFree[10];
	char           TBytes[10];
	char           UBytes[10];
	unsigned char  Columns;
	unsigned char  LLen;
	unsigned char  drivetype;
};

struct cbits {
	unsigned sort     : 3;	//0-7
	unsigned dplace   : 2;	//0-3
	unsigned display  : 5;	//0 - size, 1 - attributes, 2 - date/time, 3 - long format, 4 - long filename
	unsigned reverse  : 1;
	unsigned dformat  : 1;
	unsigned dcolor   : 1;
	unsigned dclear   : 1;
	unsigned dbrowse  : 1;
	unsigned dansi    : 1;
	unsigned sname    : 1;
	unsigned file     : 1;
	unsigned cflags   :11;	//sort 1, dplace 2, reverse 4, dformat 8, dcolor 16, dcolumns 32, dclear 64
							//dbrowse 128, dansi 256, path 512, short 1024
};

struct date_time {
	unsigned year   :11;
	unsigned second : 6;
	unsigned minute : 6;
	unsigned fhour  : 5;
	unsigned month  : 4;
	unsigned day    : 5;
};

struct file_list {
	char             name[_MAX_PATH];
	char             sname[_MAX_SNAME + _MAX_SEXT + 2];
	char             attrib;
	unsigned __int64 size;
	date_time        tdate;
};

struct tdata {
	SMALL_RECT window;
	unsigned   columns;
	unsigned   rows;
	HANDLE     screen;
	WORD       Oattrib;
	WORD       Cattrib;
};

extern cbits bgiven;            //my own structues, should be fine
extern dirinfo DInfo;
extern tdata tscreen;
extern file_list *flist;
extern unsigned long TList;
extern unsigned TRows;

extern void textval(char*,unsigned __int32,unsigned __int32,int);
extern int getswitch(char *);
extern WORD gcolor(char *);
extern void sortlist(void);
extern char readkey(void);
extern void tcolor(WORD);
extern void ShowNoFiles(char *);
extern void showhelp(void);
extern void showerr(int);
extern void ShowLine(unsigned,char *);
extern void qswap(unsigned,unsigned);

extern int cleanpath(void);  //Direct Drive access, needs tweaking.
extern int getdirinfo(void);
extern int getlist(void);

extern int getcur(void);        //Direct Video Access, replace and calling functions
extern void sclear(void);	    //should be fine.
extern void scrlback(void);
extern void lastrow(char);
extern void scrlfor(void);
extern void scurs(BOOL);
extern void c_print(char *);

#endif
