#include "stdafx.h"

__finddata64_t Entrie;


int cleanpath(void) {

	char drive[_MAX_DRIVE], dir[_MAX_DIR], name[256], ext[256];
	char *tpath;
	unsigned cdrive = (unsigned)_getdrive();
	ULONG dMask = 0;
	unsigned i = 0;
	intptr_t fHandle;

	tpath = _fullpath(NULL,DInfo.Path,_MAX_PATH);
	if (tpath == NULL) return(-4);

	while (DInfo.Path[dMask] != '\0') ++dMask;
	if ((DInfo.Path[dMask - 1] == '.') && (dMask > 1)) {
		if ((DInfo.Path[dMask - 2] != '.') && (DInfo.Path[dMask - 2] != '\\') && (DInfo.Path[dMask - 2] != ':')) {
			dMask = 1;
		} else dMask = 0;
	} else dMask = 0;

	_splitpath(tpath,drive,dir,name,ext);
	if (drive[0] > 90) drive[0] -= 32;

	if (bgiven.sname) {
		_makepath(tpath,drive,dir,"","");
		GetShortPathName(tpath,DInfo.Path,_MAX_PATH);
		_splitpath(DInfo.Path,drive,dir,NULL,NULL);
	} else _makepath(DInfo.Path,drive,dir,"","");

	free(tpath);

	if ((dMask) && (ext[0] == '\0')) {ext[0] = '.';ext[1] = '\0';}

	if (((char)cdrive + 'A' - '\1') != drive[0]) {
		if(_chdrive(int(drive[0] - 'A') + 1) != 0) return(-6);
		_chdrive(cdrive);
		_makepath(DInfo.Path,drive,"\\","","");
		if (GetFileAttributes(DInfo.Path) == 0xFFFFFFFF) return(-10);
		_makepath(DInfo.Path,drive,dir,"","");
	}

	i = 0;
	do ++i; while (DInfo.Path[i] != '\0');
	
	if (i > 3) {
		DInfo.Path[--i] = '\0';
		fHandle = _findfirst64(DInfo.Path, &Entrie);
		if (fHandle == NULL) {
			_findclose(fHandle);
			return(-5);
		}
		_findclose(fHandle);
		DInfo.Path[i++] = '\\';
		DInfo.Path[i] = '\0';
	}
	
	if ((name[0] != '\0') || (ext[0] != '\0')) {
		_makepath(DInfo.Path,drive,dir,name,ext);

		i = 0;
		while (DInfo.Path[i] != '\0') if ((DInfo.Path[i] == '*') || (DInfo.Path[i] == '?')) return(0); else ++i;
		
		fHandle = _findfirst64(DInfo.Path, &Entrie);
		if (fHandle != NULL) {
			if (!(Entrie.attrib & _A_SUBDIR)) {
				_findclose(fHandle);
				return(0);
			} else _findclose(fHandle);
		} else return(0);
	}

	if (bgiven.sname) {
		GetShortPathName(DInfo.Path,DInfo.Path,_MAX_PATH);
		i = 0;
		while (DInfo.Path[i] != '\0') ++i;
	}

	if ((i + 4) >= _MAX_PATH) return(0);

	if (DInfo.Path[i - 1] != '\\') DInfo.Path[i++] = '\\';
	DInfo.Path[i++] = '*';
	DInfo.Path[i++] = '.';
	DInfo.Path[i++] = '*';
	DInfo.Path[i] = '\0';

	return(0);
}

int getdirinfo(void) {

	unsigned i = 0, flag = 0;
	int c = 0;
	unsigned __int32 x = 0, UsedBytes = 0, TotalBytes = 0, UBOverflow = 0, TBOverflow = 0;
	unsigned __int32 BlockSize = 0, DriveBytes = 0, FreeBytes = 0, DBOverflow = 0, FBOverflow = 0;
	unsigned __int32 toverflow = 0, tsize = 0;
	char rootp[4] = "x:\\", filter = '\0';
	char const uflow[7] = "< 1 KB";
	diskfree_t Free;
	intptr_t fHandle;
	FARPROC pGetDiskFreeSpaceEx = NULL;
	unsigned __int64 i64FreeBytesToCaller, i64TotalBytes, i64FreeBytes;
	
	rootp[0] = DInfo.Path[0];

	_getdiskfree(DInfo.Path[0] - 'A' + 1, &Free);
	DInfo.drivetype = (unsigned char)GetDriveType(rootp);

	BlockSize = Free.bytes_per_sector * Free.sectors_per_cluster;

	pGetDiskFreeSpaceEx = GetProcAddress(GetModuleHandle("kernel32.dll"), "GetDiskFreeSpaceExA");
	if (pGetDiskFreeSpaceEx) {
		GetDiskFreeSpaceEx(rootp, (PULARGE_INTEGER)&i64FreeBytesToCaller, (PULARGE_INTEGER)&i64TotalBytes, (PULARGE_INTEGER)&i64FreeBytes);

		DriveBytes = (unsigned __int32)(i64TotalBytes % ((unsigned __int64)_GB_ * 4));
		DBOverflow = (unsigned __int32)(i64TotalBytes / ((unsigned __int64)_GB_ * 4));
		FreeBytes = (unsigned __int32)(i64FreeBytes % ((unsigned __int64)_GB_ * 4));
		FBOverflow = (unsigned __int32)(i64FreeBytes / ((unsigned __int64)_GB_ * 4));

	} else {
		for (x = 0; x < BlockSize; x++) {
			DriveBytes += Free.total_clusters;
			if (DriveBytes < Free.total_clusters) ++DBOverflow;
			FreeBytes += Free.avail_clusters;
			if (FreeBytes < Free.avail_clusters) ++FBOverflow;
		}
	}


	GetVolumeInformation(rootp,DInfo.DLabel,33,NULL,NULL,NULL,NULL,NULL);

	i = 0;
	while (DInfo.DLabel[i] != '\0') ++i;
	DInfo.LLen = char(i);

	fHandle = _findfirst64(DInfo.Path, &Entrie);
	if (fHandle > 0) c = 0; else c = -1;

	while (c == 0) {
		if (!(Entrie.attrib & _A_SUBDIR) || ((bgiven.dplace & 3) != 3)) {
			tsize = (unsigned __int32)(Entrie.size % ((unsigned __int64)_GB_ * 4));
			toverflow = (unsigned __int32)(Entrie.size / ((unsigned __int64)_GB_ * 4));
			x = tsize / BlockSize;
			UBOverflow += toverflow;
			TBOverflow += toverflow;
			if ((tsize % BlockSize) != 0) ++x;
			UsedBytes += (x * BlockSize);
			if (UsedBytes < (x * BlockSize)) ++UBOverflow;
			TotalBytes += tsize;
			if (TotalBytes < Entrie.size) ++TBOverflow;
			if (Entrie.attrib & _A_SUBDIR) {
				++DInfo.TDirectories;
				if (DInfo.TDirectories == 0) return(-7);
			} else {
				++DInfo.TFiles;
				if (DInfo.TFiles == 0) return(-7);
			}
			i = 0;
			flag = 0;
			while (Entrie.name[i] != '\0') if (Entrie.name[i] == '.') flag = i++; else ++i;
			if (flag == 0) flag = i; else --i;
			if (DInfo.LExt < (i - flag)) DInfo.LExt = i - flag;
			if (DInfo.LFname < flag) DInfo.LFname = flag;
		}
	c = _findnext64(fHandle,&Entrie);
	}

	_findclose(fHandle);

	if (tscreen.columns < 40) {
		if ((DBOverflow == 0) && (DriveBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveSize[c] = uflow[c];
		else textval(DInfo.DriveSize,DBOverflow,DriveBytes,6);
		if ((FBOverflow == 0) && (FreeBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveFree[c] = uflow[c];
		else textval(DInfo.DriveFree,FBOverflow,FreeBytes,6);
	} else {
		textval(DInfo.DriveSize,DBOverflow,DriveBytes,9);
		textval(DInfo.DriveFree,FBOverflow,FreeBytes,9);
	}

	if (tscreen.columns < 60) {
		if ((TBOverflow == 0) && (TotalBytes < 1000)) for (c = 0; c < 7; c++) DInfo.TBytes[c] = uflow[c];
		else textval(DInfo.TBytes,TBOverflow,TotalBytes,6);
		if ((UBOverflow == 0) && (UsedBytes < 1000)) for (c = 0; c < 7; c++) DInfo.UBytes[c] = uflow[c];
		else textval(DInfo.UBytes,UBOverflow,UsedBytes,6);
	} else {
		textval(DInfo.TBytes,TBOverflow,TotalBytes,9);
		textval(DInfo.UBytes,UBOverflow,UsedBytes,9);
	}

	return(0);
}

int getlist(void) {

	unsigned i = 0, c = 0, x = 0, flag = 0, m = 0;
	intptr_t fHandle;
	unsigned long thold = 0;
	tm *ftime;
	char sPath[_MAX_PATH];
	DWORD u = 0;

	while (DInfo.Path[i] != '\0') 
		if (DInfo.Path[i++] == '\\') flag = i;
	for (i = 0; i < flag; i++)
		sPath[i] = DInfo.Path[i];
	sPath[i] = '\0';


	fHandle = _findfirst64(DInfo.Path,&Entrie);
	if (fHandle != NULL) i = 0; else i = -1;

	while (i == 0) {
		if (!(Entrie.attrib & _A_SUBDIR) || (bgiven.dplace != 3)) {
			flist[c].attrib = Entrie.attrib;
			flist[c].size = Entrie.size;

			ftime = _localtime64(&Entrie.time_write);
			flist[c].tdate.second = ftime->tm_sec;
			flist[c].tdate.minute = ftime->tm_min;
			flist[c].tdate.fhour = ftime->tm_hour;
/*			if (ftime->tm_isdst) {
				if (flist[c].tdate.fhour > 0) --flist[c].tdate.fhour;
				else flist[c].tdate.fhour += 23;
			} */
			flist[c].tdate.day = ftime->tm_mday;
			flist[c].tdate.month = ftime->tm_mon;
			flist[c].tdate.year = ftime->tm_year;

			x = 0;
			if (((Entrie.name[0] == '.') && (Entrie.name[1] == '\0')) || \
				((Entrie.name[0] == '.') && (Entrie.name[1] == '.') && (Entrie.name[2] == '\0'))) {
				while (Entrie.name[x] != '\0') {
					flist[c].name[x] = Entrie.name[x];
					flist[c].sname[x] = Entrie.name[x++];
				}
				flist[c].name[x] = '.';
				flist[c].sname[x++] = '.';
				flist[c].name[x] = '\0';
				flist[c].sname[x] = '\0';
			} else {
				m = 0;
				while (Entrie.name[m] != '\0') {flist[c].name[m] = Entrie.name[m];++m;}
				m = 0;
				flag = 0;
				while(Entrie.name[x] != '\0'){
					if ((Entrie.name[x] > 126) || (Entrie.name[x] < 32)) m = 1;
					if (Entrie.name[x] == '.') flag = x++; else ++x;
				}
				if (flag == 0) flag = x;
				if ((m == 1) || (flag > (_MAX_SNAME)) || ((x - flag) > (_MAX_SEXT + 1))) {
					x = 0;
					while (sPath[x] != '\0') if (sPath[x++] == '\\') flag = x;
					m = 0;
					x = flag;
					while ((Entrie.name[m] != '\0') && (x < (_MAX_PATH - 1))) sPath[x++] = Entrie.name[m++];
					sPath[x] = '\0';
					if (Entrie.name[m] != '\0') {_findclose(fHandle);return(-8);}
					GetShortPathName(sPath,sPath,_MAX_PATH);
					m = 0;
					x = flag;
					while (sPath[x] != '\0') Entrie.name[m++] = sPath[x++];
					Entrie.name[m] = '\0';
					sPath[flag] = '\0';
				} 
				flag = 0;
				x = 0;
				while (Entrie.name[x] != '\0') if (Entrie.name[x] == '.') flag = x++; else ++x;
				if (flag == 0) flag = x;
				if (flag > _MAX_SNAME) {
					for (m = 0; m < (_MAX_SNAME - 1); m++) flist[c].sname[m] = Entrie.name[m];
					flist[c].sname[m++] = '*';
				} else {
					for (m = 0; m < flag; m++) flist[c].sname[m] = Entrie.name[m];
				}
				if ((x - flag) > (_MAX_SEXT + 1)) {
					for (x = 0; x < _MAX_SEXT; x++) flist[c].sname[m++] = Entrie.name[x + flag];
					flist[c].sname[m++] = '*';
					flist[c].sname[m] = '\0';
				} else {
					while (Entrie.name[flag] != '\0') flist[c].sname[m++] = Entrie.name[flag++];
					flist[c].sname[m] = '\0';
				}
			}
		}
		++c;
		i = _findnext64(fHandle,&Entrie);
	}

	_findclose(fHandle);
	return(0);
}

